/************************************************************** 2007.4.9 *****/
//  PTPTOC3.c : XY{bgPTP^̍ŒZԐ                              //
//  PCQA[[ɏWʂ                                       //
//  Newton@ɂ؂ւƏI[Ԃ߂                             //
/*****************************************************************************/
#include    <stdio.h>
#include    <stdlib.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    <conio.h>

#define   MMAX          1001

//#define   pai           3.14159265358979
extern double deg;
//----------- {bg -------------------------------------------//
extern char   sgn;                 //='a':~W{bgC'b':SCARA{bg
extern char   sgnG;                //='g':d͍lL
extern char   sgnM;                //='m':ʌ덷C='n'Fʌ덷Ȃ
extern double CYLT1max, CYLT2max,  //~W{bgd͂̊֐ߍőgN[Nm,N]
              CYLTG1max, CYLTG2max,//~W{bgLd͂̊֐ߍőgN[Nm,N]
              CYLIJ1, CYLIJ2,      //~W{bg֐1,2̃A[[kgm^2,kg]
			  CYLIMJ1, CYLIMJ2,    //~W{bg[^̊֐ߎZl[kgm^2,kg]
			  cylfi0[2], cylfif[2],//~W{bg֐ߕψʂ̏lI[l[rad,m]
			  cyltt[4],            //TOC̐؂ւEI[[s]
			  cylpm[4][2];         //~W{bggN؂ւp^[
extern double SCT1max, SCT2max,    //SCARA{bgd͂̊֐ߍőgN[Nm]
              SCTG1max, SCTG2max,  //SCARA{bgLd͂̊֐ߍőgN[Nm]
              SCIJ1, SCIJ2,        //SCARA{bg1,2A[̎芵[gkgm^2]
			  SCIMJ1, SCIMJ2,      //SCARA{bg1,2[^̎Zlkgm^2]
			  scfi0[2], scfif[2],  //SCARA{bg֐ߕψʂ̏lI[l[rad]
			  sctt[4],             //TOC̐؂ւEI[[s]
			  scpm[4][2];          //SCARA{bggN؂ւp^[
extern double FIREF[4][2], VFIREF[4][2]; //4؂ւ̊֐ߕψʁEx
extern double scl1, scl2;          //SCARA{bgA[[m]
extern double cyll;                //~W{bgA[[m]
extern double m1, mw;              //1,2A[[(~W{bgmw)[kg]

//----------- ԂƎԊ֐ ------------------------------------------//
static double tt[4];                //ԍ݁C؂ւƏI[
//static double tf0;                //TOCłȂʒuߎ
//static double yy0[4], yyf[4];     //֐ߕψʑx̏lCI[l
static double TIME[MMAX];          //Ԃ̎nisԊuj
static double FI[2][MMAX],VFI[2][MMAX]; //֐ߕψʁEx̎n
static double err0, errs=1.0e-4;   //I[l덷̘aCvZł؂wW
static double J[4][4];             //؂ւC̕Rr
static int    n=50;                //RKGvZeԂ̎ԍݐ
static int    sgnsol;              //=1:sol()vZ
static int    sgncalJ;             //=1:J()vZ
static int    sgncaltt;            //=1:؂ւttvZ
static int    sgn1, sgn2;          //n߂̑1,2gN̕(}1)
static int    mmt[4][2];           //=1:T1,2max, =-1:-T1,2max
static int    n1, n2;              //1,2֐߂̐؂ւ(1 or 2)
static int    nrepeat, nmax=400;   //Newton@̌JԂ񐔁Cő

int    calTOCtime();    //؂ւvZ
void   rkgTOC();
double TOCf();          //
double totalerr();      //abs(y)
int    sol();           //^̏I[lvZ
double Jacobian();      //؂ւCRr
double imatrx();        //ts
int    calttorder();    //؂ւ̕בւƊeԂ̃gN̐

/************ TOCf() *********************************************************/
//    OsɊւ^
/**************************************************************************/
double TOCf(int i, int mt[], double tt[], double t, double y[])
{
	static double yy, cf2, sf2;
	static double C1, C2, T1, T2, TT1, TT2, I[2][2], detI, TG1, TG2;
	static double acc1, acc2;
	static double err=1.0e-5;

	if(i==0) { yy = y[2]; return yy; }
	if(i==1) { yy = y[3]; return yy; }

 if(sgn=='a')
 {
	//---------- т̕؂ւ --------------------------------------------//
	if(sgnG=='h') { T1 = mt[0]*CYLT1max;   T2 = mt[1]*CYLT2max;  }
	if(sgnG=='g') { T1 = mt[0]*CYLTG1max;  T2 = mt[1]*CYLTG2max; }
    //-------- d^2/dt^2 ------------------------------------//
	if(i==2)
	{
      //--------- d̓gN ----------------------------------//
	  if(sgnG=='g')  TG1 = 9.8*mw*y[1]*cos(y[0]);  else  TG1 = 0;
	  //--------- ֐߉x -------------------------------------//
	  yy = (T1 - 2*mw*y[1]*y[2]*y[3] - TG1)/(CYLIMJ1+mw*y[1]*y[1]);
	}
	//-------- d^2r/dt^2 -------------------------------------//
	if(i==3)
	{ if(sgnG=='g')  TG2 = 9.8*mw*sin(y[0]);  else  TG2 = 0;
      yy = (T2 + mw*y[1]*y[2]*y[2] - TG2)/(CYLIMJ2+mw);
	}
 }
 if(sgn=='b')
 {
	//-------- d^21/dt^2, d^22/dt^2 ----------------------//
	if(i==2 || i==3)
	{
	 //---------- т̕؂ւ --------------------------------------------//
	 if(sgnG=='h') { T1 = mt[0]*SCT1max;   T2 = mt[1]*SCT2max;  }
	 if(sgnG=='g') { T1 = mt[0]*SCTG1max;  T2 = mt[1]*SCTG2max; }
	 //-------- RI ----------------------//
	 cf2 = cos(y[1]);   sf2 = sin(y[1]);
 	 C2 = mw*scl1*scl2*sf2*y[2]*y[2];
	 C1 = C2 - mw*scl1*scl2*sf2*(y[2]+y[3])*(y[2]+y[3]);
	 //-------- d͍ --------------------------//
	 if(sgnG=='g')
	 {  TG2 = 9.8*mw*scl2*cos(y[0]+y[1]);
	    TG1 = 9.8*(m1+mw)*scl1*cos(y[0]) + TG2;
	 }  else  TG1 = TG2 = 0;
	 //-------- ֐߉gN ------------------//
	 TT1 = T1 - C1 - TG1;
	 TT2 = T2 - C2 - TG2;
     //-------- W ---------------------//
	 I[1][1] = SCIJ2 + SCIMJ2;
	 I[0][1] = I[1][0] = SCIJ2 + mw*scl1*scl2*cf2;
	 I[0][0] = SCIJ1 + SCIMJ1 + SCIJ2 + mw*scl1*(scl1 + 2*scl2*cf2);
	 detI = I[0][0]*I[1][1] - I[1][0]*I[0][1];
	 //-------- ֐߉x ----------------------//
	 acc1 = ( I[1][1]*TT1 - I[0][1]*TT2)/detI;
	 acc2 = (-I[1][0]*TT1 + I[0][0]*TT2)/detI;
	 if(i==2) yy = acc1;
	 if(i==3) yy = acc2;
	}
 }
 return yy;
}
/**************** TOCf() end ***************************************************/

/*******************************************************************************/
//  vOPTPTOC.C main()̏                                        //
/*******************************************************************************/
int calTOCtime(void)
{
	int     i, k, sgnsol, sgnTOC;
	double  II1, tf0, tt0[4], yy0[4], yyf[4], yy4[4], dyy[4], ddt[4], det;
    double  ddtotal, c;         //؂ւCl̘aCClkW
	double  TIME1[MMAX], FI1[2][MMAX], VFI1[2][MMAX];
	double  TIME2[MMAX], FI2[2][MMAX], VFI2[2][MMAX];
	double  ttorder[4], tts1[4], tts2[4];
	int     mmt1[4][2], mmt2[4][2];
/*
	if(sgn=='a')    printf("\n~W{bgPTPŒZԐ");
	if(sgn=='b')    printf("\nSCARA{bgPTPŒZԐ");
	if(sgnG=='g')   printf("\nd͍l");
	if(sgnG!='g')   printf("\nd͍lȂ");
*/	
	//------------- (2) EI[ ------------------------------//
	if(sgn=='a')
	{
		//---------- ֐ߕψʑxlݒ ------------------------//
		yy0[0] = cylfi0[0];  	yy0[1] = cylfi0[1];  //(,r)̏l
	    yy0[2] = yy0[3] = 0;
		//---------- ֐ߕψʑxI[lݒ ------------------------//
		yyf[0] = cylfif[0];     yyf[1] = cylfif[1];  //(,r)̏I[l
		yyf[2] = yyf[3] = 0;
		//-------- ӂlI[l܂ōőƂ̏v -----//
		II1 = CYLIMJ1 + mw*yy0[1]*yy0[1];
		tf0 = 2*sqrt(II1/CYLT1max*fabs(yyf[0]-yy0[0]));
/*
		if(sgnG=='h')
		printf("\nőgNT1max=%6.2f[Nm] ő쓮Fmax=T2max=%6.2f[N]",CYLT1max,CYLT2max);
		if(sgnG=='g')
		printf("\nőgNTG1max=%6.2f[Nm] ő쓮FGmax=TG2max=%6.2f[N]",CYLTG1max,CYLTG2max);
	    printf("\n=%5.2f[rad], r=%5.2f[m]",yy0[0],yy0[1]);
	    printf("\nI[=%5.2f[rad], r=%5.2f[m]",yyf[0],yyf[1]);
		printf("\n`II1=%7.4f[kg/m^2]",II1);
		printf("\n     FBCtf0=%7.4f[s]",tf0);
*/
	}
	if(sgn=='b')
	{
		//---------- ֐ߕψʑxlݒ ------------------------//
		yy0[0] = scfi0[0]; 	   yy0[1] = scfi0[1];  //(1,2)̏l
	    yy0[2] = yy0[3] = 0;
		//---------- ֐ߕψʑxI[lݒ ------------------------//
		yyf[0] = scfif[0];     yyf[1] = scfif[1];  //(1,2)̏I[l
		yyf[2] = yyf[3] = 0;
		//-------- 1lI[l܂ōőƂ̏v -----//
		II1 = SCIMJ1 + SCIJ1 + mw*(scl1+scl2*cos(yy0[1]))*(scl1+scl2*cos(yy0[1]));
		tf0 = 2*sqrt(II1/SCT1max*fabs(yyf[0]-yy0[0]));
/*
	    printf("\nA[(scl1,scl2)=(%6.2f %6.2f)[m]",scl1,scl2);
		if(sgnG=='h')
		printf("\nőgNT1max=%6.2f[Nm] T2max=%6.2f[Nm]",SCT1max,SCT2max);
		if(sgnG=='g')
		printf("\nőgNTG1max=%6.2f[Nm] TG2max=%6.2f[Nm]",SCTG1max,SCTG2max);
	    printf("\n1=%5.2f[rad], 2=%5.2f[rad]",yy0[0],yy0[1]);
	    printf("\nI[1=%5.2f[rad], 2=%5.2f[rad]",yyf[0],yyf[1]);
		printf("\n`II1=%7.4f[kg/m^2]",II1);
		printf("\n      FBCtf=%7.4f[s]",tf0);
*/
	}

	//------------ ؂ւtt[]̏l ----------------------------//
	//------ J1gN̐؂ւ񐔁CJ2gN̐؂ւ񐔌Œ --------//
	n1 = 1;   n2 = 2;
	if(yyf[0]-yy0[0]>0)   sgn1 = 1;   else   sgn1 = -1;
	//--------- ؂ւ̏l -----------------------------------//
	if(sgnM=='n')
	{
		tt0[3] = 0.6*tf0;
	    tt0[0] = 0.25*tt0[3];  tt0[1] = 0.5*tt0[3];  tt0[2] = 0.75*tt0[3];
	}
	if(sgnM=='m')
	{
		if(sgn=='a')  for(i=0;i<4;i++)  tt0[i] = cyltt[i];
	    if(sgn=='b')  for(i=0;i<4;i++)  tt0[i] = sctt[i];
	}

	//----- Pڂsgn2=-1CQڂsgn2=1łꂼ̉߂ ----//
	sgn2 = -1;
q1:
	for(i=0;i<4;i++)  tt[i] = tt0[i];

//printf("\n؂ւ tt0[]=(%7.4f %7.4f %7.4f %7.4f)\n",tt0[0],tt0[1],tt0[2],tt0[3]);

//--------------- ؂ւtt[]߂Newton@ -------------------------//

    nrepeat = 0;
p1:
	//------------ ̏I[ԌvZƏI[덷 --------------//
	sgnsol = sol(tt, yy0, yy4, ttorder);
	for(i=0;i<4;i++)  dyy[i] = yyf[i] - yy4[i];
	err0 = totalerr(4, dyy);
/*
//if(sgn2==1)
{
printf("\nmw=%5.3f[kg]  sgn2=%d",mw,sgn2);
printf("\nnr=%3d ڕWyyf[]=(%10.5f %10.5f %10.5f %10.5f)",nrepeat,yyf[0],yyf[1],yyf[2],yyf[3]);
printf("\n       yy4[]=(%10.5f %10.5f %10.5f %10.5f)",yy4[0],yy4[1],yy4[2],yy4[3]);
printf("\n dyy[]=(%10.2e %10.2e %10.2e %10.2e) (abs(dyy[])=%10.2e"
	,dyy[0],dyy[1],dyy[2],dyy[3],err0);//getch();
}
*/
	if(err0<errs)  goto p2;

	//------------ 덷炷iInverse[Jocobian]jvZ ----------------//
	det = Jacobian(yy0, tt, J);

	//------------ tt[]̏C ----------------------------------//
//if(sgn2==1)
// printf("\nOtt[]=(%11.6f %11.6f %11.6f %11.6f)",tt[0],tt[1],tt[2],tt[3]);

	for(i=0;i<4;i++)
	{   ddt[i] = 0;
	    for(k=0;k<4;k++)  ddt[i] = ddt[i] + J[i][k]*dyy[k];
	    ddtotal = totalerr(4, ddt);
	}
	if(ddtotal>=1.0)  c = 0.05/ddtotal;
	if(1.0>ddtotal && ddtotal>=0.1)  c = 0.05;
	if(0.1>ddtotal && ddtotal>=0.01) c = 0.5;
	if(0.01>ddtotal) c = 0.2;
	if(0.001>ddtotal) c = 0.5;
	if(0.0001>ddtotal) c = 1 ;
	for(i=0;i<4;i++)  tt[i] = tt[i] + c*ddt[i];
/*
//if(sgn2==1)
{
printf("\n ddt[]=(%11.6f %11.6f %11.6f %11.6f) det[J]=%11.3e",ddt[0],ddt[1],ddt[2],ddt[3],det);
printf("\ntt[]=(%11.6f %11.6f %11.6f %11.6f) c=%7.4f",tt[0],tt[1],tt[2],tt[3],c);
getch();
}
*/
    nrepeat++;
	//----------- 덷ȂƂ͉Ȃ ------------------------//
	if(nrepeat>=nmax)
	{
/*		printf("\nJԂvZ>%d  vZ~ L͌vZr̒l",nrepeat);
        printf("\n؂ւ tt[]=(%11.6f %11.6f %11.6f %11.6f)",tt[0],tt[1],tt[2],tt[3]);
        printf("\n        ڕWyyf[]=(%11.6f %11.6f %11.6f %11.6f)",yyf[0],yyf[1],yyf[2],yyf[3]);
        printf("\n        yy4[]=(%11.6f %11.6f %11.6f %11.6f)",yy4[0],yy4[1],yy4[2],yy4[3]);
        printf("\n dyy[]=(%10.2e %10.2e %10.2e %10.2e) (abs(dyy[])=%10.2e   "
	        ,dyy[0],dyy[1],dyy[2],dyy[3],err0);getch();
*/
		tt[3] = ttorder[3] = 1.0e10;    goto p2;
	}
	else  goto  p1;

	//------------- vZȈ --------------------------------------------//
p2:
	//----------- tt[]̂PłΉƂȂ ------------//
//printf("\n\n sgn2=%2d tt[]     =(%8.5f %8.5f %8.5f %8.5f)",sgn2,tt[0],tt[1],tt[2],tt[3]);
	if(tt[0]<0 || tt[1]<0 || tt[2]<0)
	{    tt[3] = ttorder[3] = 1.0e10;
//printf("\n   tt[]̂PȏオDƂȂ");
	}
	if(tt[2]>tt[3])
	{    tt[3] = ttorder[3] = 1.0e10;
//printf("\n   t3>tf@ƂȂ");
	}
	//---------- Pڂ̉̉ -------------------------------------//
	if(sgn2==-1)
	{
		for(i=0;i<4;i++)
		{ tts1[i] = ttorder[i]; mmt1[i][0] = mmt[i][0]; mmt1[i][1] = mmt[i][1]; }
		//------ Pڂ̉̎n ---------------------------//
        for(k=0;k<=4*n;k++)
		{ TIME1[k]=TIME[k]; FI1[0][k]=FI[0][k]; FI1[1][k]=FI[1][k];
          VFI1[0][k]=VFI[0][k]; VFI1[1][k]=VFI[1][k]; }
/*
printf("\nFBCtf=%7.4f[s]",tf0);
printf("\n   sgn2=%1d ttorder[]=(%8.5f %8.5f %8.5f %8.5f)"
	   ,sgn2,ttorder[0],ttorder[1],ttorder[2],ttorder[3]);
printf("\n   mmt[][0]=(%2d %2d %2d %2d)",mmt[0][0],mmt[1][0],mmt[2][0],mmt[3][0]);
printf("\n   mmt[][1]=(%2d %2d %2d %2d)",mmt[0][1],mmt[1][1],mmt[2][1],mmt[3][1]);
for(i=0;i<4;i++)
printf("\nPTPTOC2.H i=%1d (i+1)*n=%3d FICON[]=(%7.4f %7.4f)  VFICON[]=(%7.4f %7.4f)"
	   ,i,(i+1)*n,FI1[0][(i+1)*n],FI1[1][(i+1)*n],VFI1[0][(i+1)*n],VFI1[1][(i+1)*n]);
getch();
*/

		//---- Qsgn2=1̌vZ -----//
		sgn2 = 1;   nrepeat = 0;
		for(i=0;i<4;i++)  tt[i] = tt0[i];
		goto q1;
	}
	//---------- Qڂ̉ -------------------------------------//
	if(sgn2==1)
	{
		for(i=0;i<4;i++)
		{ tts2[i] = ttorder[i]; mmt2[i][0] = mmt[i][0]; mmt2[i][1] = mmt[i][1]; }
		//------ Qڂ̉̎n ---------------------------//
        for(k=0;k<=4*n;k++)
		{ TIME2[k]=TIME[k]; FI2[0][k]=FI[0][k]; FI2[1][k]=FI[1][k];
          VFI2[0][k]=VFI[0][k]; VFI2[1][k]=VFI[1][k]; }

/*
printf("\nFBCtf=%7.4f[s]",tf0);
printf("\n   sgn2=%2d ttorder[]=(%8.5f %8.5f %8.5f %8.5f)"
	   ,sgn2,ttorder[0],ttorder[1],ttorder[2],ttorder[3]);
printf("\n   mmt[][0]=(%2d %2d %2d %2d)",mmt[0][0],mmt[1][0],mmt[2][0],mmt[3][0]);
printf("\n   mmt[][1]=(%2d %2d %2d %2d)",mmt[0][1],mmt[1][1],mmt[2][1],mmt[3][1]);
*/
	}

//end:
	//============ (0) sgn2=1,-1ƂȂ =================================//
	if(tts1[3]>1000 && tts2[3]>1000)	{  sgnTOC = 0; goto end1; }
	//=========== (1)  ===============================================//
	//----------- (2-1) tf1<tf2̂Ƃsgn2=-1 ---------//
	if(tts1[3]<tts2[3])   for(i=0;i<4;i++)
	{
		ttorder[i] = tts1[i];  mmt[i][0] = mmt1[i][0];  mmt[i][1] = mmt1[i][1];
        for(k=0;k<=4*n;k++)
		{  TIME[k]=TIME1[k]; FI[0][k]=FI1[0][k]; FI[1][k]=FI1[1][k];
           VFI[0][k]=VFI1[0][k]; VFI[1][k]=VFI1[1][k]; }
	}
	//----------- (2-2) tf1>tf2̂Ƃsgn2=1 -----------//
	else   for(i=0;i<4;i++)
	{
		ttorder[i] = tts2[i];  mmt[i][0] = mmt2[i][0];  mmt[i][1] = mmt2[i][1];
        for(k=0;k<=4*n;k++)
		{  TIME[k]=TIME2[k]; FI[0][k]=FI2[0][k]; FI[1][k]=FI2[1][k];
           VFI[0][k]=VFI2[0][k]; VFI[1][k]=VFI2[1][k]; }
	}
	//-------------- (3) ؂ւ̊֐ߕψʑxFSOTOC̎Qƒl --------//
	for(i=0;i<4;i++)
	{    FIREF[i][0] = FI[0][(i+1)*n];   VFIREF[i][0] = VFI[0][(i+1)*n];
         FIREF[i][1] = FI[1][(i+1)*n];   VFIREF[i][1] = VFI[1][(i+1)*n];

//printf("\nPTPTOC2.H i=%3d FICON[]=(%7.4f %7.4f)  VFICON[]=(%7.4f %7.4f)"
//	   ,i,FIREF[i][0],FIREF[i][1],VFIREF[i][0],VFIREF[i][1]);
	}

	//---------- (4) ꂽ؂ւ̌ʂu ------------------//
	if(sgn=='a')  for(i=0;i<4;i++)
	{   cyltt[i] = ttorder[i];
	    cylpm[i][0] = mmt[i][0];    cylpm[i][1] = mmt[i][1];
	}
	if(sgn=='b')  for(i=0;i<4;i++)
	{
		sctt[i]  = ttorder[i];
	    scpm[i][0] = mmt[i][0];	    scpm[i][1] = mmt[i][1];
	}
	sgnTOC = 1;

end1:
/*
//--------------- ꂽ̈ ---------------------------------//
printf("\n");
if(sgnTOC==0)  printf("\nsgn2=1,2ƂȂ");
else
{
printf("\n\n̗p");
printf("    FBCtf=%7.4f[s]",tf0);
printf("\nttorder[]=(%8.5f %8.5f %8.5f %8.5f)",ttorder[0],ttorder[1],ttorder[2],ttorder[3]);
printf("\nmmt[][0]=(%2d %2d %2d %2d)",mmt[0][0],mmt[1][0],mmt[2][0],mmt[3][0]);
printf("\nmmt[][1]=(%2d %2d %2d %2d)",mmt[0][1],mmt[1][1],mmt[2][1],mmt[3][1]);
for(i=0;i<=4*n;i++)  if(i==5*(i/5))
printf("\ni=%3d t=%6.3f  FI[]=(%9.5f %9.5f)   VFI[]=(%9.5f %9.5f)"
 ,i,TIME[i],FI[0][i],FI[1][i],VFI[0][i],VFI[1][i]);
printf("\n     ڕW      FIf[]=(%9.5f %9.5f)  VFIf[]=(%9.5f %9.5f)"
,yyf[0],yyf[1],yyf[2],yyf[3]);
printf("\nttorder[]=(%8.5f %8.5f %8.5f %8.5f)",ttorder[0],ttorder[1],ttorder[2],ttorder[3]);
printf("\n1[]=(%2d %2d %2d %2d)",mmt[0][0],mmt[1][0],mmt[2][0],mmt[3][0]);
printf("\n2[]=(%2d %2d %2d %2d)",mmt[0][1],mmt[1][1],mmt[2][1],mmt[3][1]);
}
if(sgnTOC==0)  printf("\nPTPTOC3.H   ttorder[]=Ȃ");
if(sgnTOC==1){
printf("\nPTPTOC3.H   ttorder[]=(%8.5f %8.5f %8.5f %8.5f)",ttorder[0],ttorder[1],ttorder[2],ttorder[3]);
for(i=0;i<4;i++)
printf("\nPTPTOC3.H FIREF[%d][]=(%7.4f %7.4f)  VFIREF[%d][]=(%7.4f %7.4f)"
	   ,i,FIREF[i][0],FIREF[i][1],i,VFIREF[i][0],VFIREF[i][1]);
//getch();
}
*/
	return sgnTOC;
}
/***************** main()calTOCtime() end *****************************/

/***************** 덷̘a err=abs(dyy[]) ****************************/
double totalerr(int K, double dyy[])
{
	int    i;
	double err;

	err = 0;
	for(i=0;i<K;i++)  err = err + fabs(dyy[i]);
	return err;
}
/**************** totalerr() end ****************************************/

/***************** O *******************************************/
//   ֐߃gN̐͂Ō߂
/************************************************************************/
int sol(double tt[], double yy0[], double yy4[], double ttorder[])
{
	int    sign, i, isol;
	static double t, dt, dt0=0.01, yy2[4];

	sign = calttorder(tt, ttorder, mmt); //؂ւ̕בւƊeԂ̃gN̐
	if(sign==0)
	{  printf("\nԎŏIԂ𒴂DvZ~");  return (0); }
	t = 0;
	isol = 0;
	TIME[0] = 0;
    yy4[0] = yy0[0];   yy4[1] = yy0[1];
    yy4[2] = yy0[2];   yy4[3] = yy0[3];

FI[0][0]  = yy0[0];   FI[1][0]  = yy0[1];
VFI[0][0] = yy0[2];   VFI[1][0] = yy0[3];

	//----------- ̉(eԋ؂ŌvZ) -------------//
//	if(t<=ttorder[0])
	{  dt = ttorder[0]/n;
	   for(i=0;i<n;i++)
	   {   yy2[0] = yy4[0];    yy2[1] = yy4[1];
	       yy2[2] = yy4[2];    yy2[3] = yy4[3];
	       rkgTOC(mmt[0], ttorder, t, dt, yy2, yy4, 4);
		   t = t + dt;
		   isol = i+1;
		   TIME[isol] = t;
           FI[0][isol]  = yy4[0];   FI[1][isol]  = yy4[1];
           VFI[0][isol] = yy4[2];   VFI[1][isol] = yy4[3];
	   }
	}
	 t = ttorder[0];
//	 if(ttorder[0]<=t && t<=ttorder[1])
	 {  dt = (ttorder[1]-ttorder[0])/n;
	    for(i=0;i<n;i++)
		{  yy2[0] = yy4[0];    yy2[1] = yy4[1];
	       yy2[2] = yy4[2];    yy2[3] = yy4[3];
	       rkgTOC(mmt[1], tt, t, dt, yy2, yy4, 4);
		   t = t + dt;
		   isol = i + 1 + n;
		   TIME[isol] = t;
           FI[0][isol]  = yy4[0];   FI[1][isol]  = yy4[1];
           VFI[0][isol] = yy4[2];   VFI[1][isol] = yy4[3];
		}
	 }
	 t = ttorder[1];
//	 if(ttorder[1]<=t && t<=ttorder[2])
	 {  dt = (ttorder[2]-ttorder[1])/n;
	    for(i=0;i<n;i++)
		{  yy2[0] = yy4[0];    yy2[1] = yy4[1];
	       yy2[2] = yy4[2];    yy2[3] = yy4[3];
	       rkgTOC( mmt[2], tt, t, dt, yy2, yy4, 4);
		   t = t + dt;
		   isol = i + 1 + 2*n;
		   TIME[isol] = t;
           FI[0][isol]  = yy4[0];   FI[1][isol]  = yy4[1];
           VFI[0][isol] = yy4[2];   VFI[1][isol] = yy4[3];
		}
	 }
	 t = ttorder[2];
//	 if(ttorder[2]<=t)
	 {  dt = (ttorder[3]-ttorder[2])/n;
	    for(i=0;i<n;i++)
		{  yy2[0] = yy4[0];    yy2[1] = yy4[1];
	       yy2[2] = yy4[2];    yy2[3] = yy4[3];
	       rkgTOC( mmt[3], tt, t, dt, yy2, yy4, 4);
		   t = t + dt;
		   isol = i + 1 + 3*n;
		   TIME[isol] = t;
           FI[0][isol]  = yy4[0];   FI[1][isol]  = yy4[1];
           VFI[0][isol] = yy4[2];   VFI[1][isol] = yy4[3];
		}
	 }  
/*
//if(sgncalJ!=1)
for(isol=0;isol<=4*n;isol++)
{
if(isol<n) i=isol; if(n<=isol && isol<2*n) i=isol-n;
if(2*n<=isol && isol<3*n) i=isol-2*n; if(3*n<=isol)  i=isol-3*n;
if(isol==5*(isol/5))
printf("\ni=%3d isol=%3d  t=%7.4f[s] (%7.4f %7.4f %7.4f %7.4f)"
	   ,i,isol,TIME[isol],FI[0][isol],FI[1][isol],VFI[0][isol],VFI[1][isol]);
}
getch();
*/
	 return (1);
}
/***************** sol() end *****************************************/

/************ ؂ւ̎ԏɕׁCgN̐߂ *******/
//    tt[] : ؂ւ
//    ttorder[] : ԏ
//    mt[][2] : eԋ1,2gN̐
/*********************************************************************/
int calttorder( double tt[], double ttorder[], int mmt[4][2])
{
/*
	//------------- Ȃԏ ---------------------------------//
	if(tt[0]>tt[2])
	{  printf("\n؂ւ t1>t3(%6.3f>%6.3f)  vZ~@",tt[0],tt[2]);
	   return (0);
	}
	if(tt[2]>tt[3])
	{  printf("\n؂ւ t3>tf(%6.3f>%6.3f)  vZ~@",tt[2],tt[3]);
	   return (0);
	}
	if(tt[1]>tt[3])
	{  printf("\n؂ւ t2>tf(%6.3f>%6.3f)  vZ~@",tt[1],tt[3]);
	   return (0);
	}
*/
	//--------------- t ------------------------------------------//
	ttorder[3] = tt[3];
	mmt[0][0]= sgn1;
	mmt[0][1]= sgn2;
	if(tt[1]<=tt[0])
	{  ttorder[0] = tt[1]; ttorder[1] = tt[0];  ttorder[2] = tt[2];
  	   if(n1==1 && n2==2)
	   {   mmt[1][0]=-sgn1;   mmt[2][0]=-sgn1; mmt[3][0]=-sgn1;
	       mmt[1][1]= sgn2;   mmt[2][1]=-sgn2; mmt[3][1]= sgn2;
	   }
	   if(n1==2 && n2==1)
	   {   mmt[1][0]= sgn1;   mmt[2][0]=-sgn1; mmt[3][0]= sgn1;
	       mmt[1][1]=-sgn2;   mmt[2][1]=-sgn2; mmt[3][1]=-sgn2;
	   }
    }
	if(tt[0]<tt[1] && tt[1]<=tt[2])
	{  ttorder[0] = tt[0]; ttorder[1] = tt[1];  ttorder[2] = tt[2];
  	   if(n1==1 && n2==2)
	   {   mmt[1][0]= sgn1;   mmt[2][0]=-sgn1; mmt[3][0]=-sgn1;
	       mmt[1][1]=-sgn2;   mmt[2][1]=-sgn2; mmt[3][1]= sgn2;
	   }
	   if(n1==2 && n2==1)
	   {   mmt[1][0]=-sgn1;   mmt[2][0]=-sgn1; mmt[3][0]= sgn1;
	       mmt[1][1]= sgn2;   mmt[2][1]=-sgn2; mmt[3][1]=-sgn2;
	   }
    }
	if(tt[2]<=tt[1])
	{  ttorder[0] = tt[0]; ttorder[1] = tt[2];  ttorder[2] = tt[1];
  	   if(n1==1 && n2==2)
	   {   mmt[1][0]= sgn1;   mmt[2][0]= sgn1; mmt[3][0]=-sgn1;
	       mmt[1][1]=-sgn2;   mmt[2][1]= sgn2; mmt[3][1]= sgn2;
	   }
	   if(n1==2 && n2==1)
	   {   mmt[1][0]=-sgn1;   mmt[2][0]= sgn1; mmt[3][0]= sgn1;
	       mmt[1][1]= sgn2;   mmt[2][1]= sgn2; mmt[3][1]=-sgn2;
	   }
    }
/*
printf("\ncalttorder() (n1,n2)=(%d %d) mt[][]=(%d %d) (%d %d) (%d %d) (%d %d)"
	 ,n1,n2,mmt[0][0],mmt[0][1],mmt[1][0],mmt[1][1],mmt[2][0],mmt[2][1],mmt[3][0],mmt[3][1]);
printf("\nttorder=(%6.3f %6.3f %6.3f %6.3f)",ttorder[0],ttorder[1],ttorder[2],ttorder[3]);
*/
	return (1);
}
/***************** calttorder() end ************************************/

/*************** 덷炷iJacobian)vZ *********************/
double Jacobian(double yy0[], double tt[], double J[4][4])
{
	int    i;
	static double tt1[4], tt2[4], tt3[4], tt4[4], ttorder[4];
	static double dt=0.005;
	static double yyf0[4], yyf1[4], yyf2[4], yyf3[4], yyf4[4];
	static double dyy1[4];
	static double J1[4][4], det;
//	static double J2[4][4], err1;  //eXgp
//  int     k;

	//----------- ݂̏I[l ---------------//
	sgncalJ = sol(tt, yy0, yyf0, ttorder);
	//----------- Ȃdet=1.0e10Ԃ -------//
	if(sgncalJ==0)    return (1,0e10);

//printf("\nڕW           yyf[] =(%8.5f %8.5f %8.5f %8.5f)",yyf[0],yyf[1],yyf[2],yyf[3]);
//printf("\nJ() 0          yyf0[]=(%8.5f %8.5f %8.5f %8.5f)",yyf0[0],yyf0[1],yyf0[2],yyf0[3]);

	//------------- J[][0]=dyy[]/dt1 --------------------------------//
	for(i=0;i<4;i++)   tt1[i] = tt[i];
	tt1[0] = tt[0] + dt;
	sgncalJ = sol(tt1, yy0, yyf1, ttorder);
/*
printf("\nJ() 1 dt=%5.3f yyf1[]=(%8.5f %8.5f %8.5f %8.5f)",dt,yyf1[0],yyf1[1],yyf1[2],yyf1[3]);
for(i=0;i<4;i++) dyy1[i]=yyf1[i]-yyf0[i];
err1=totalerr(4, dyy1);
if(err1<1.0e-5) {sgncalJ=2;sol(tt,yy0,yyf0);sol(tt1,yy0,yyf1);getch();}//sol()Ŏԕω
sgncalJ=1;
*/
	for(i=0;i<4;i++)  J[i][0] = J1[i][0] = (yyf1[i] - yyf0[i])/dt;
	//------------- J[][1]=dyy[]/dt2 --------------------------------//
	for(i=0;i<4;i++)   tt2[i] = tt[i];
	tt2[1] = tt[1] + dt;
	sgncalJ = sol(tt2, yy0, yyf2, ttorder);
//printf("\nJ() 2 dt=%5.3f yyf2[]=(%8.5f %8.5f %8.5f %8.5f)",dt,yyf2[0],yyf2[1],yyf2[2],yyf2[3]);
	for(i=0;i<4;i++)  J[i][1] = J1[i][1] = (yyf2[i] - yyf0[i])/dt;
	//------------- J[][2]=dyy[]/dt3 --------------------------------//
	for(i=0;i<4;i++)   tt3[i] = tt[i];
	tt3[2] = tt[2] + dt;
	sgncalJ = sol(tt3, yy0, yyf3, ttorder);
//printf("\nJ() 3 dt=%5.3f yyf3[]=(%8.5f %8.5f %8.5f %8.5f)",dt,yyf3[0],yyf3[1],yyf3[2],yyf3[3]);
	for(i=0;i<4;i++)  J[i][2] = J1[i][2] = (yyf3[i] - yyf0[i])/dt;
	//------------- J[][3]=dyy[]/dt4 --------------------------------//
	for(i=0;i<4;i++)   tt4[i] = tt[i];
	tt4[3] = tt[3] + dt;
	sgncalJ = sol(tt4, yy0, yyf4, ttorder);
	for(i=0;i<4;i++)  J[i][3] = J1[i][3] = (yyf4[i] - yyf0[i])/dt;

//printf("\nJ() 4 dt=%5.3f yyf4[]=(%8.5f %8.5f %8.5f %8.5f)",dt,yyf4[0],yyf4[1],yyf4[2],yyf4[3]);
/*
printf("\nJ[0][]=(%11.3e %11.3e %11.3e %11.3e)",J1[0][0],J1[0][1],J1[0][2],J1[0][3]);
printf("\n  J[1][]=(%11.3e %11.3e %11.3e %11.3e)",J1[1][0],J1[1][1],J1[1][2],J1[1][3]);
printf("\n  J[2][]=(%11.3e %11.3e %11.3e %11.3e)",J1[2][0],J1[2][1],J1[2][2],J1[2][3]);
printf("\n  J[3][]=(%11.3e %11.3e %11.3e %11.3e)",J1[3][0],J1[3][1],J1[3][2],J1[3][3]);
*/
	//------------- ts ------------------------------------------//
	det = imatrx(4, J, 4);
/*
printf("\ntJ[0][]=(%11.3e %11.3e %11.3e %11.3e)",J[0][0],J[0][1],J[0][2],J[0][3]);
printf("\n  J[1][]=(%11.3e %11.3e %11.3e %11.3e)",J[1][0],J[1][1],J[1][2],J[1][3]);
printf("\n  J[2][]=(%11.3e %11.3e %11.3e %11.3e)",J[2][0],J[2][1],J[2][2],J[2][3]);
printf("\n  J[3][]=(%11.3e %11.3e %11.3e %11.3e)",J[3][0],J[3][1],J[3][2],J[3][3]);
printf("\ndet=%11.3e",det);
//getch();
for(i=0;i<4;i++){
for(k=0;k<4;k++)
J2[i][k]=J1[i][0]*J[0][k]+J1[i][1]*J[1][k]+J1[i][2]*J[2][k]+J1[i][3]*J[3][k];
printf("\nJ1*J[%d][]=(%11.3e %11.3e %11.3e %11.3e)",i,J2[i][0],J2[i][1],J2[i][2],J2[i][3]);
}
*/
	return det;
}
/***************** Jacobian() end ************************************/

/********(1-2) rkgTOC() ************************************************/
//    mt[4][2] : eԂ1,2gN̐=1:T1max  =-1:-T1max
//    tt[] : ؂ւ
//    t, dt : ԁCԍ
//    z0[], z4[] : lCI[l
//    n    : ̐
/*********************************************************************/
#define   NRKG   20
void rkgTOC(int mt[], double tt[], double t, double dt, double z0[], double z4[], int n)
{
   double a1=0.292893219, a2=1.70710678, a3=0.16666667;
   double z1[NRKG],z2[NRKG],z3[NRKG];
   double k0[NRKG],k1[NRKG],k2[NRKG],k3[NRKG];
   double r1[NRKG],r2[NRKG],r3[NRKG],r4[NRKG];
   double q1[NRKG],q2[NRKG],q3[NRKG],q4[NRKG];
   int    i;

   for(i=0;i<n;i++)
      {
	   k0[i]=dt*TOCf(i,mt,tt,t,z0);        r1[i]=0.5*k0[i];
       z1[i]=z0[i]+r1[i];         q1[i]=3*r1[i]-0.5*k0[i];
      }
   for(i=0;i<n;i++)
      {k1[i]=dt*TOCf(i,mt,tt,t+0.5*dt,z1); r2[i]=a1*(k1[i]-q1[i]);
       z2[i]=z1[i]+r2[i];         q2[i]=q1[i]+3*r2[i]-a1*k1[i];
      }
   for(i=0;i<n;i++)
      {k2[i]=dt*TOCf(i,mt,tt,t+0.5*dt,z2); r3[i]=a2*(k2[i]-q2[i]);
       z3[i]=z2[i]+r3[i];         q3[i]=q2[i]+3*r3[i]-a2*k2[i];
     }
   for(i=0;i<n;i++)
      {k3[i]=dt*TOCf(i,mt,tt,t+dt,z3);     r4[i]=a3*(k3[i]-2*q3[i]);
       z4[i]=z3[i]+r4[i];         q4[i]=q3[i]+3*r4[i]-0.5*k3[i];
      }
 }
/*******(1-2) rkgTOC() end ***************************************************/

/**(2-2)*****************************************************************/
// imatrx(n, *a, nmax)	n:dimension, *a:double array nmax:a[nmax][nmax] //
// det = imatrx(n, a, nmax);						                    //
/************************************************************************/
double	imatrx(int n, double *a, int nmax)
{
 int	    i, j, k, mi, mk, *ipv, *w, *v;
 double 	*lu, s, t, det;

/*printf("\nimatrx()");
printf("\n*a=(%7.4f %7.4f %7.4f)",*a,*(a+1),*(a+2));
printf("\n   (%7.4f %7.4f %7.4f)",*(a+nmax),*(a+nmax+1),*(a+nmax+2));
printf("\n   (%7.4f %7.4f %7.4f)",*(a+2*nmax),*(a+2*nmax+1),*(a+2*nmax+2));
*/

	if (((lu = (double *)calloc(n * n, sizeof(double))) == NULL)
	  ||((ipv = (int *)calloc(n, sizeof(int))) == NULL)
	  ||((w = (int *)calloc(n, sizeof(int))) == NULL)
	  ||((v = (int *)calloc(n, sizeof(int))) == NULL)) {
		printf("memory overflow\n");
		exit(1);
	}
	//---- LU decomposition ----//
	for (i = 0; i < n; i++)
		for (j = 0; j < n; j++)
			*(lu+n*i+j) = *(a+nmax*i+j);
	for (k = 0; k < n; k++)
		ipv[k] = k;
	for (k = 0; k < n; k++) {
		i = k;
		s = fabs(*(lu+n*ipv[k]+k));
		for (j = k + 1; j < n; j++) {
			t = fabs(*(lu+n*ipv[j]+k));
			if (t > s) { i = j; s = t; }
		}
		j = ipv[k]; ipv[k] = ipv[i]; ipv[i] = j;
		mk = ipv[k];
		s = *(lu+n*mk+k);
		for (i = k + 1; i < n; i++) {
			mi = ipv[i];
			t = *(lu+n*mi+k) / s;
			*(lu+n*mi+k) = t;
			for (j = k + 1; j < n; j++)
				*(lu+n*mi+j) -= t * *(lu+n*mk+j);
		}
	}
	//---- determinant -----------------//
	for (i = 0; i < n; i++) v[i] = ipv[i];
	for (i = 0; i < n; i++) w[v[i]] = i;
	det = 1.0;
	for (i = 0; i < n - 1; i++) {
		j = v[i];
		if (j != i) {
			v[w[i]] = j; 
			w[j] = w[i]; 
			det = -det;
		}
	}
	for (i = 0; i < n; i++) det *= *(lu+n*ipv[i]+i);
	//----- inverse matrix -----//
	if (fabs( det ) > 1.0e-6) {
		for (k = 0; k < n; k++) {
			for (i = 0; i < n; i++) {
				mi = ipv[i];
				if (mi == k) t = 1.0;
				else	    t = 0.0;
				for (j = 0; j <= i - 1; j++)
					t -= *(lu+n*mi+j) * *(a+nmax*j+k);
				*(a+nmax*i+k) = t;
			}
			for (i = n - 1; i >= 0; i--) {
				mi = ipv[i];
				t = *(a+nmax*i+k);
				for (j = i + 1; j < n; j++)
					t -= *(lu+n*mi+j) * *(a+nmax*j+k);
				*(a+nmax*i+k) = t / *(lu+n*mi+i);
			}
		}
	}
	//---- return ----//
	free( ipv );
	free( lu );
	free( w );
	free( v );
/*
printf("\nimatrx() inverse");
printf("\n*a=(%7.4f %7.4f %7.4f)",*a,*(a+1),*(a+2));
printf("\n   (%7.4f %7.4f %7.4f)",*(a+nmax),*(a+nmax+1),*(a+nmax+2));
printf("\n   (%7.4f %7.4f %7.4f)",*(a+2*nmax),*(a+2*nmax+1),*(a+2*nmax+2));
*/
	return( det );
}
/*******(2) imatrx() end ***********************************************/
